import { FlclLogger, FlclError } from "fc-logger";
//import TokenManager from 'fc-token-manager';
import ShopifyTokenManager from "fc-token-manager/src/shopifyTokenManager";
import Redis from './redis';

export interface ArgsForTokenSystem {
    REDIS_HOST: string,
    REDIS_PORT: string,
    REDIS_PASS: string,
    REDIS_DB: string,
    // redisInstance: {
    //     client: RedisClient,
    //     redlock: Redlock
    // }
    tokenizedCall: boolean,
    // storeName: string
}

export interface MiddlewareParams extends ArgsForTokenSystem {
    logger?: FlclLogger,
    FlclError?: typeof FlclError,
}

export interface AppObj {
    logger: FlclLogger,
    FlclError: typeof FlclError,
    tokenizedCall: boolean,
    tokenManagerParams?: {
        // storeName: string,
        REDIS_HOST: string,
        REDIS_PORT: string,
        REDIS_DB: string,
        REDIS_PASS: string
    }
    // redisInstance: {
    //     client: RedisClient,
    //     redlock: Redlock
    // },
    redisInstance: Redis,
    shopifyTokenManager: any
}

export interface ArgsForTokenManager {
    logger?: FlclLogger,
    FlclError?: typeof FlclError,
    storeName: string,
    // redisInstance: {
    //     client: RedisClient,
    //     redlock: Redlock
    // }
    redisInstance: Redis | undefined
}

export interface ValidObject {
    [x: string]: string | number | boolean | object | [] | any
}

export interface AxiosMiddleware {
    get: Function,
    post: Function,
    put: Function
}